<template>
  <v-dialog v-model="dialogPax" @click:outside="close" max-width="90%">
    <v-card class="pa-8">
      <v-card-title class="justify-center text-h5 d-flex font-weight-bold">
        {{ dialogTitle }}
      </v-card-title>
      <v-divider class="mt-2 mb-6"></v-divider>

      <FlightsCasePaxForm v-if="legs" :pax="pax" :legs="legs" />

      <v-card-actions class="justify-center d-flex">
        <v-btn variant="outlined" rounded size="large" data-cy="PaxFormCloseBtn" class="text-uppercase" @click="close()">
          Annuler
        </v-btn>
        <v-btn variant="outlined" rounded size="large" data-cy="PaxFormOkBtn" class="text-uppercase inverted" :disabled="!meta.valid"
          :loading="loading" @click="confirm()">
          Valider
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">
import { Pax } from "~/dto/pax.dto";
import { Leg } from "~/dto/leg.dto";

const dialogPax = defineModel<boolean>()

const props = defineProps<{
  pax: Pax,
  legs: Leg[]
}>()

const { validate, meta } = useForm({
  initialValues: props.pax
})

const emit = defineEmits(['close', 'confirm'])

const loading = ref(false);
const dialogTitle = ref('');
const form: Ref<any> = ref(null);

const close = () => {
  emit('close')
}

const confirm = async () => {
  const { valid } = await validate();
  if (!valid) {
    return;
  }
  emit('confirm');
  loading.value = true;
}

dialogTitle.value = props.pax.id ? `Édition d'un PAX` : `Création d'un PAX`;

</script>
